import pandas as pd
import numpy as np
import datetime
from LIB.MIDDLE.CellStateEstimation.Common.V1_0_1 import BatParam

class SafetyWarning:
    def __init__(self,sn,celltype,df_short,df_liplated,df_uniform):  #参数初始化

        self.sn=sn
        self.celltype=celltype
        self.param=BatParam.BatParam(celltype)
        self.df_short=df_short
        self.df_liplated=df_liplated
        self.df_uniform=df_uniform
    
    def diag(self):
        if self.celltype<=50:
            df_res=self._warning_diag()
            return df_res    
        else:
            df_res=self._warning_diag()
            return df_res
        

    #电池热安全预警诊断功能.................................................................................................
    def _warning_diag(self):

        df_res=pd.DataFrame(columns=['start_time', 'end_time', 'product_id', 'code', 'level', 'info','advice'])

        time=datetime.datetime.now()
        time_sp='0000-00-00 00:00:00'

        #参数初始化
        shortfault=0
        liplatedfault=0
        uniformfault=0

        for i in range(self.param.CellVoltNums):

            #漏电流故障判断...........................................................................
            if not self.df_short.empty:
                short_current=self.df_short['short_current']
                short_current=short_current.str.replace("[", '')
                short_current=short_current.str.replace("]", '')
                self.df_short['cellshort'+str(i+1)]=short_current.map(lambda x:eval(x.split(',')[i]))

                cellshort=self.df_short['cellshort'+str(i+1)]
                index_list=cellshort[cellshort<self.param.LeakCurrentLv2].index
                if len(index_list)==2 and (index_list[1]-index_list[0])==1:
                    shortfault=1
                elif len(index_list)>3:
                    shortfault=1
                else:
                    shortfault=0
            
            #析锂故障判断...............................................................................
            if not self.df_liplated.empty:
                liplated=self.df_liplated['liplated_amount']
                liplated=liplated.str.replace("[", '')
                liplated=liplated.str.replace("]", '')
                self.df_liplated['liplated_amount'+str(i+1)]=liplated.map(lambda x:eval(x.split(',')[i]))

                if max(self.df_liplated['liplated_amount'+str(i+1)])>30:
                    liplatedfault=1
                else:
                    liplatedfault=0
            else:
                liplatedfault=0

            #电芯SOC排名判断.............................................................................
            if not self.df_uniform.empty:
                if (i+1) in self.df_uniform['cellmin_num'].tolist():
                    uniformfault=1
                else:
                    uniformfault=0
            else:
                uniformfault=0
            
            #电池热安全预警
            if shortfault==1 and (liplatedfault==1 or uniformfault==1):
                faultcode=110
                faultlv=4
                faultinfo='电芯{}发生热失控安全预警'.format(i+1)
                faultadvice='联系用户远离电池，立刻召回电池'
                df_res.loc[0]=[time, time_sp, self.sn, faultcode, faultlv, faultinfo, faultadvice]
            else:
                pass
            
        return df_res
